> For the complete documentation index, see [llms.txt](https://docs.non-obvious.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.non-obvious.ai/sdks-guide/blockchain-sdks/wallet-sdk/getkeys/sol.md).

# sol

## Description

The `getKeys` function generates a private key and a corresponding public address using a given mnemonic phrase. The function returns the private key and public address as a result object.

## Parameters

| Parameter  | Type   | Description                                    |
| ---------- | ------ | ---------------------------------------------- |
| `mnemonic` | string | A 12-24 word mnemonic phrase for key creation. |

## Response

| Field    | Type   | Description                                                          |
| -------- | ------ | -------------------------------------------------------------------- |
| `code`   | number | A status code indicating whether the function was successful or not. |
| `result` | object | An object containing the private key and public address.             |
| `error`  | string | A string describing the error that occurred, if applicable.          |

## Example Request and Response

### Prerequisites

Before making requests with NO.AI SDK, you must have it installed.

You can install NO.AI SDK using either **`npm`** or **`yarn`**. Use the following commands to install NO.AI SDK:

```sh
npm install @nest25/wallet-lib
OR
yarn add @nest25/wallet-lib
```

### Request

Here is an example of how to make a `getKeys` request using the NO.AI SDK:

{% code overflow="wrap" %}

```javascript
// import Nest SDK
import { Wallet } from 'nest25/wallet-lib';

// Create a new instance of the Wallet class
const wallet = new Wallet();
// test mnemonic for BTC mainnet (use the createWallet function to get one)
const testMnemonic = 'divorce poverty spend fire symbol market good skull rebel surge giggle album';

const main = async () => {
  // get the keys for the sol network
  const response = await wallet.getKeys('sol', testMnemonic);
  // log the response
  console.log(response);
};

main();
```

{% endcode %}

### Response

{% code overflow="wrap" %}

```sh
{
        code: 1,
        result: {
          privateKey: '61hqSActTebg2cgmRyoeBdSHxq348HQhzs4EqGA9SRTCCChnNB4fKFoFLaLrTfLNxEyTJzVfbgrz7nqD6PN6X8ag',
          address: 'Byz7G9nWucTkErWFR5QzLSAre9TdBak3nB6GUbRjgNzg'
        }
}
```

{% endcode %}

## Use Cases

* **Crypto Wallet:** Crypto wallets can use this function to generate private keys and corresponding public addresses for their users.
* **Testing:** Blockchain developers can use this function to generate private keys and addresses for testing and development purposes.

###


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.non-obvious.ai/sdks-guide/blockchain-sdks/wallet-sdk/getkeys/sol.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
